# -*- coding: utf-8 -*-
"""
Created on Fri Mar  8 11:11:38 2024

@author: aleja
"""

import numpy as np
import pandas as pd
import matplotlib.pyplot as plt

variables = np.load('fich_datos_DPCA.npz')

p=variables['p']
sa=variables['sa']
Qumbral=variables['Qumbral']
Tumbral=variables['Tumbral']
valor_medio=variables['valor_medio']
desviacion_estandar=variables['desviacion_estandar']


#datos = pd.read_csv('d01_te.csv')
datos = pd.read_csv('d21_te.csv')

shape = datos.shape
n=len(datos.axes[0])
m=len(datos.axes[1])


#2 normalizar a media conocida y varianza 1
variable_centralizada = datos - valor_medio

X = variable_centralizada / desviacion_estandar
Xn=X.to_numpy()

Xn_1 = np.roll(Xn, 1, axis=1)
Xn_1[:, 0] = Xn[:, 0]

Xn_2 = np.roll(Xn_1, 1, axis=1)
Xn_2[:, 0] = Xn_1[:, 0]


Xn_3 = np.roll(Xn_2, 1, axis=1)
Xn_3[:, 0] = Xn_2[:, 0]


XD = np.concatenate((Xn,Xn_1, Xn_2, Xn_3), axis=1)


T2=[]
for i in range (n):
    
    multi=np.dot(np.dot(np.dot(np.dot(XD[i,:], p), np.linalg.inv(sa)), np.transpose(p)), np.transpose(XD[i,:]))

    T2=np.append(T2,multi)
    
  
 #calcular la estadistica Q

Q=[]

for i in range(n):
    R=XD[i,:]-np.dot(np.dot(XD[i,:],p),np.transpose(p))
    Rt=np.transpose(R) #para que de la forma adecuada
    Qi=np.dot(Rt,R)
    Q=np.append(Q,Qi)
    
    
ejex=np.arange(n)

plt.title('Estadistico T^2 de Hotelling')
plt.xlabel('t')
plt.ylabel('T^2')
plt.scatter(ejex, T2, c ="green")
plt.axhline(y=Tumbral, color="r", label="Percentil 99")
plt.show()


plt.title('Estadistico Q')
plt.xlabel('t')
plt.ylabel('Q')
plt.scatter(ejex, Q, c ="blue")
plt.axhline(y=Qumbral, color="r", label="Percentil 99")
plt.show()  


#detectar fallos
t_falloT=0
con=0
k=10
fallo=0
for i in range (0,n):
    if T2[i]>Tumbral:
        con=con+1
    else:
        con=0
        
    if con==k:
        fallo =1
        t_falloT=i-9
        break
    
    
print('tiempo para T2',t_falloT)  

  
con=0    
t_falloQ=0
for i in range (0,n):
    if Q[i]>Qumbral:
         con=con+1
    else:
         con=0
        
    if con==k:
        fallo =1
        t_falloQ=i-9
        break
    
#print('tiempo para Q',t_falloQ)
#falsas alarmas
cont=0
for i in range(159):
    if T2[i]>Tumbral:
        cont=cont+1

falsa_alarmaT=cont/160*100

print('falsas alarmas para T2',falsa_alarmaT)

cont2=0
for i in range(159):
    if Q[i]>Qumbral:
        cont2=cont2+1

falsa_alarmaQ=cont2/160*100

#print('falsas alarmas para Q',falsa_alarmaQ)

#alarmas detectadas
con=0
for i in range (160,n):
    if T2[i]>Tumbral:
        con=con+1

alarma_detectadaT=con/800*100
print(' alarmas detectadas para T2',alarma_detectadaT)

con2=0
for i in range (160,n):
    if Q[i]>Qumbral:
        con2=con2+1

alarma_detectadaQ=con2/800*100
#print(' alarmas detectadas para Q',alarma_detectadaQ)


print('tiempo para Q',t_falloQ)
print('falsas alarmas para Q',falsa_alarmaQ)
print(' alarmas detectadas para Q',alarma_detectadaQ)

#################### identificacion fallo

#R_fallo=XD[t_falloQ,:]
R_fallo=XD[t_falloQ,:]-np.dot(np.dot(XD[t_falloQ,:],p),np.transpose(p))

R_fallo2=np.square(R_fallo)
plt.bar(range(len(R_fallo2)), R_fallo2)
plt.title('DPCA Diagrama de barras de R_fallo2 d07')
plt.show()

# Encontrar el valor máximo y su índice
max_valor = np.max(R_fallo2)
max_indice = np.argmax(R_fallo2)
print(f'posición {max_indice}')

